<template>

  <!-- TODO: vue-bootstrap -->
  <form id="register-form" class="form" @submit.prevent="register">
    <div v-if="errors.non_field_errors" class="field-error">
      {{errors.non_field_error[0]}}
    </div>

    <div class="form-group">
      <label for="email" class="text-info">Email addres:</label><br>
      <input v-model="email" type="text" id="email" class="form-control">
      <div v-if="errors.email" class="field-error">{{errors.email[0]}}</div>
    </div>
    <div class="form-group">
      <label for="password" class="text-info">Wachtwoord:</label><br>
      <input v-model="password" type="password" id="password" class="form-control">
      <div v-if="errors.password" class="field-error">{{errors.password[0]}}</div>
    </div>
    <div class="form-group">
      <label for="password_confirm" class="text-info">Wachtwoord herhalen:</label><br>
      <input v-model="password_confirm" type="password" id="password_confirm" class="form-control">
      <div v-if="errors.password_confirm" class="field-error">{{errors.password_confirm[0]}}</div>
    </div>

    <hr>

    <div class="form-group">
      <label for="first-name" class="text-info">Voornaam:</label><br>
      <input v-model="first_name" type="text" id="first-name" class="form-control">
      <div v-if="errors.first_name" class="field-error">{{errors.first_name[0]}}</div>
    </div>
    <div class="form-group">
      <label for="last-name" class="text-info">Achternaam:</label><br>
      <input v-model="last_name" type="text" id="last-name" class="form-control">
      <div v-if="errors.last_name" class="field-error">{{errors.last_name[0]}}</div>
    </div>

    <div class="form-group">
      <button type="submit" class="btn btn-success btn-md">
        Registreren
        <span v-if="isRegistrationPending" class="spinner-border spinner-border-sm" role="status">
          <span class="sr-only">Laden..</span>
        </span>
      </button>
    </div>

    <hr>
    <div class="text-info m-2"><p>Heeft u al een account?</p></div>
    <div @click="$router.push('login');" class="btn btn-info btn-md">
      Naar login scherm
    </div>
    <hr>
  </form>
</template>

<script>
import {mapGetters} from "vuex";

import {REGISTER_REQUEST} from "@/store/actions/register";

export default {
name: "RegisterForm",
  data() {
    return {
      email: "",
      password: "",
      password_confirm: "",
      first_name: "",
      last_name: "",
      errors: {}
    }
  },
  methods: {
    register: function() {
      const {email, password, password_confirm, first_name, last_name} = this
      this.$store.dispatch(REGISTER_REQUEST, {
        email,
        password,
        password_confirm,
        first_name,
        last_name
      }).catch(error => {
        this.$set(this, 'errors', error.response.data);
      })
    }
  },
  computed: {
    ...mapGetters(["isRegistrationPending"])
  }
}
</script>

<style scoped>

</style>
